#!/usr/bin/awk -f

function print_header(title)
{
	print "Content-Type: text/html"
 	print ""
# 	print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">"

	print "<HTML><HEAD>"
	print "<META http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\">"
	printf("<TITLE>%s</TITLE>\n", title);
	printf("</HEAD><BODY><H1>%s</H1>", title);
}

function print_footer()
{
#	print "<P><A href=\"index.html\">߂</A></P>"
	print "<P><A href=\"index.html\">߂</A></P>"
	print "</BODY></HTML>"
}

function table_header(item1, item2)
{
	printf("<FORM action=\"%s\"><TABLE border=\"1\"><TBODY><TR>", action)
	printf("<TD width=\"%d\" align=\"center\">%s</TD>\n", width1, title1)
	printf("<TD width=\"%d\" align=\"center\">%s</TD></TR>\n", width2, title2)
}

function table_body(name, value, len)
{
	printf("<TR><TD width=\"%d\">%s</TD>\n", width1, name)
	printf("<TD width=\"%d\"><INPUT size=\"%d\" type=\"text\" maxlength=\"%d\" name=\"%s\" value=\"%s\">",
	       width2, len, len, name, value)
	print "</TD></TR>"
}

function table_footer()
{
	print "</TBODY></TABLE>"
	print "<P><INPUT type=\"submit\" value=\"XV\"></FORM>"
}

BEGIN{
	network_conf = "/etc/sysconfig/network"
	resolv_conf = "/etc/resolv.conf"
	if_conf = "/etc/sysconfig/network-scripts/ifcfg-eth0"
	action = "network_update.cgi"
	title = "network ݒmFEύX"
	item1 = ""
	item2 = "ݒl"
	width1 = 120
	width2 = 150

	print_header(title);

	i = 1;
	while(getline <resolv_conf > 0) {
		if($1 == "nameserver") {
			INDEX[i] = $2;
			i++;
		}
	}
	while(getline <network_conf > 0) {
                j = index($0, "=");
                INDEX[substr($0, 1, j-1)] = substr($0, j+1);
	}
	while(getline <if_conf > 0) {
                j = index($0, "=");
                INDEX[substr($0, 1, j-1)] = substr($0, j+1);
	}

	table_header(item1, item2)

	table_body("HOSTNAME", INDEX["HOSTNAME"], 30)
	table_body("IPADDR", INDEX["IPADDR"], 15)
	table_body("NETMASK", INDEX["NETMASK"], 15)
	table_body("GATEWAY", INDEX["GATEWAY"], 15)
	table_body("DNS1", INDEX[1], 15)
	table_body("DNS2", INDEX[2], 15)

	table_footer()

	print_footer()
}
